libstdc++: std::vector< bool, _Alloc > Class Template Reference

libstdc++

std::vector< bool, _Alloc > Class Template Reference
Containers » Sequences

`#include <vector>`

Inheritance diagram for std::vector< bool, _Alloc >:
[legend]

## Public Types
typedef _Alloc | allocator_type
typedef _Bit_const_iterator | const_iterator
typedef const bool * | const_pointer
typedef bool | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef ptrdiff_t | difference_type
typedef _Bit_iterator | iterator
typedef _Bit_reference * | pointer
typedef _Bit_reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef size_t | size_type
typedef bool | value_type

## Public Member Functions
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
constexpr | vector (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
constexpr | vector (const allocator_type &__a) noexcept
constexpr | vector (const vector &__x)
constexpr | vector (const vector &__x, const __type_identity_t< allocator_type > &__a)
constexpr | vector (initializer_list< bool > __l, const allocator_type &__a=allocator_type())
constexpr | vector (size_type __n, const allocator_type &__a=allocator_type())
constexpr | vector (size_type __n, const bool &__value, const allocator_type &__a=allocator_type())
| vector (vector &&)=default
constexpr | vector (vector &&__x, const __type_identity_t< allocator_type > &__a) noexcept(_Bit_alloc_traits::_S_always_equal())
constexpr auto | _M_emplace_aux (const_iterator __position, _Args &&... __args) -> iterator
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
constexpr void | assign (_InputIterator __first, _InputIterator __last)
constexpr void | assign (initializer_list< bool > __l)
constexpr void | assign (size_type __n, const bool &__x)
constexpr reference | at (size_type __n)
constexpr const_reference | at (size_type __n) const
constexpr reference | back ()
constexpr const_reference | back () const
constexpr const_iterator | begin () const noexcept
constexpr iterator | begin () noexcept
constexpr size_type | capacity () const noexcept
constexpr const_iterator | cbegin () const noexcept
constexpr const_iterator | cend () const noexcept
constexpr void | clear () noexcept
constexpr const_reverse_iterator | crbegin () const noexcept
constexpr const_reverse_iterator | crend () const noexcept
template<typename... _Args>
constexpr iterator | emplace (const_iterator __pos, _Args &&... __args)
template<typename... _Args>
constexpr reference | emplace_back (_Args &&... __args)
constexpr bool | empty () const noexcept
constexpr const_iterator | end () const noexcept
constexpr iterator | end () noexcept
constexpr iterator | erase (const_iterator __first, const_iterator __last)
constexpr iterator | erase (const_iterator __position)
constexpr void | flip () noexcept
constexpr reference | front ()
constexpr const_reference | front () const
constexpr allocator_type | get_allocator () const
constexpr allocator_type | get_allocator () const noexcept
constexpr iterator | insert (const_iterator __p, initializer_list< bool > __l)
iterator | insert (const_iterator __position)
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>
constexpr iterator | insert (const_iterator __position, _InputIterator __first, _InputIterator __last)
constexpr iterator | insert (const_iterator __position, const bool &__x)
constexpr iterator | insert (const_iterator __position, size_type __n, const bool &__x)
constexpr size_type | max_size () const noexcept
constexpr vector & | operator= (const vector &__x)
constexpr vector & | operator= (initializer_list< bool > __l)
constexpr vector & | operator= (vector &&__x) noexcept(_Bit_alloc_traits::_S_nothrow_move())
constexpr reference | operator[] (size_type __n)
constexpr const_reference | operator[] (size_type __n) const
constexpr void | pop_back ()
constexpr void | push_back (bool __x)
constexpr const_reverse_iterator | rbegin () const noexcept
constexpr reverse_iterator | rbegin () noexcept
constexpr const_reverse_iterator | rend () const noexcept
constexpr reverse_iterator | rend () noexcept
constexpr void | reserve (size_type __n)
constexpr void | resize (size_type __new_size, bool __x=bool())
constexpr void | shrink_to_fit ()
constexpr size_type | size () const noexcept
constexpr void | swap (vector &__x) noexcept

## Static Public Member Functions
static constexpr size_t | _S_max_size (const _Tp_alloc_type &__a) noexcept
static constexpr void | swap (reference __x, reference __y) noexcept

## Protected Types
typedef __gnu_cxx::__alloc_traits< _Alloc >::template rebind< _Bit_type >::other | _Bit_alloc_type

## Protected Member Functions
constexpr pointer | _M_allocate (size_t __n)
constexpr _Alloc_result | _M_allocate_and_copy (size_type __n, _ForwardIterator __first, _ForwardIterator __last)
constexpr _Alloc_result | _M_allocate_at_least (size_t __n)
template<typename _ForwardIterator>
constexpr void | _M_assign_aux (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _InputIterator>
constexpr void | _M_assign_aux (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
constexpr void | _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
constexpr size_type | _M_check_len (size_type __n, const char *__s) const
constexpr iterator | _M_copy_aligned (const_iterator __first, const_iterator __last, iterator __result)
constexpr void | _M_create_storage (size_t __n)
constexpr void | _M_deallocate ()
constexpr void | _M_deallocate (pointer __p, size_t __n)
constexpr void | _M_deallocate (pointer __p, size_t __n)
constexpr void | _M_default_append (size_type __n)
constexpr void | _M_default_initialize (size_type __n)
constexpr iterator | _M_erase (iterator __first, iterator __last)
constexpr iterator | _M_erase (iterator __pos)
constexpr void | _M_erase_at_end (iterator __pos)
constexpr void | _M_fill_append (size_type __n, const value_type &__x)
constexpr void | _M_fill_assign (size_t __n, bool __x)
constexpr void | _M_fill_initialize (size_type __n, const value_type &__value)
constexpr void | _M_fill_insert (iterator __position, size_type __n, bool __x)
constexpr const _Bit_alloc_type & | _M_get_Bit_allocator () const noexcept
constexpr _Bit_alloc_type & | _M_get_Bit_allocator () noexcept
constexpr const _Tp_alloc_type & | _M_get_Tp_allocator () const noexcept
constexpr _Tp_alloc_type & | _M_get_Tp_allocator () noexcept
constexpr void | _M_initialize (size_type __n)
template<typename _ForwardIterator>
constexpr void | _M_initialize_range (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _InputIterator>
constexpr void | _M_initialize_range (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
constexpr void | _M_initialize_value (bool __x) noexcept
constexpr void | _M_insert_aux (iterator __position, bool __x)
constexpr void | _M_insert_dispatch (iterator __pos, _Integer __n, _Integer __val, __true_type)
template<typename _InputIterator>
constexpr void | _M_insert_range (iterator __pos, _InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator>
constexpr void | _M_insert_range (iterator __position, _ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
constexpr iterator | _M_insert_rval (const_iterator __position, value_type &&__v)
constexpr void | _M_move_data (_Bvector_base &&__x) noexcept
constexpr void | _M_range_check (size_type __n) const
constexpr void | _M_range_initialize (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
constexpr void | _M_range_initialize_n (_Iterator __first, _Sentinel __last, size_type __n)
constexpr void | _M_range_insert (iterator __pos, _InputIterator __first, _InputIterator __last, std::input_iterator_tag)
constexpr void | _M_realloc_append (_Args &&... __args)
constexpr void | _M_realloc_insert (iterator __position, _Args &&... __args)
constexpr void | _M_reallocate (size_type __n)
constexpr void | _M_replace_storage (pointer __start, pointer __end, size_type __cap)
constexpr void | _M_replace_with (size_type __n, _ForwardIterator __first, _ForwardIterator __last)
constexpr bool | _M_shrink_to_fit ()
void | data ()=delete

## Static Protected Member Functions
static constexpr size_type | _S_check_init_len (size_type __n, const allocator_type &__a)
static constexpr size_t | _S_nword (size_t __n)

## Protected Attributes
_Vector_impl | _M_impl

## Friends
struct | std::hash< vector >

## Detailed Description

template<typename _Alloc>
class std::vector< bool, _Alloc >

A specialization of vector for booleans which offers fixed time access to individual elements in any order.

Since
  C++98

Template Parameters

  _Alloc | Allocator type.

Note that vector<bool> does not actually meet the requirements for being a container. This is because the reference and pointer types are not really references and pointers to bool. See DR96 for details.

See also
  vector for function documentation.

In some terminology a vector can be described as a dynamic C-style array, it offers fast and efficient access to individual elements in any order and saves the user from worrying about memory and size allocation. Subscripting ( ``[] ) access is also provided as with C-style arrays.

Definition at line 749 of file stl_bvector.h.

## Member Typedef Documentation

## ◆ _Bit_alloc_type

template<typename _Alloc>

typedef __gnu_cxx::__alloc_traits<_Alloc>::template rebind<_Bit_type>::other std::_Bvector_base< _Alloc >::_Bit_alloc_type
| inherited

Definition at line 538 of file stl_bvector.h.

## ◆ allocator_type

template<typename _Alloc>

typedef _Alloc std::vector< bool, _Alloc >::allocator_type

Definition at line 775 of file stl_bvector.h.

## ◆ const_iterator

template<typename _Alloc>

typedef _Bit_const_iterator std::vector< bool, _Alloc >::const_iterator

Definition at line 772 of file stl_bvector.h.

## ◆ const_pointer

template<typename _Alloc>

typedef const bool* std::vector< bool, _Alloc >::const_pointer

Definition at line 770 of file stl_bvector.h.

## ◆ const_reference

template<typename _Alloc>

typedef bool std::vector< bool, _Alloc >::const_reference

Definition at line 768 of file stl_bvector.h.

## ◆ const_reverse_iterator

template<typename _Alloc>

typedef std::reverse_iterator<const_iterator> std::vector< bool, _Alloc >::const_reverse_iterator

Definition at line 773 of file stl_bvector.h.

## ◆ difference_type

template<typename _Alloc>

typedef ptrdiff_t std::vector< bool, _Alloc >::difference_type

Definition at line 766 of file stl_bvector.h.

## ◆ iterator

template<typename _Alloc>

typedef _Bit_iterator std::vector< bool, _Alloc >::iterator

Definition at line 771 of file stl_bvector.h.

## ◆ pointer

template<typename _Alloc>

typedef _Bit_reference* std::vector< bool, _Alloc >::pointer

Definition at line 769 of file stl_bvector.h.

## ◆ reference

template<typename _Alloc>

typedef _Bit_reference std::vector< bool, _Alloc >::reference

Definition at line 767 of file stl_bvector.h.

## ◆ reverse_iterator

template<typename _Alloc>

typedef std::reverse_iterator<iterator> std::vector< bool, _Alloc >::reverse_iterator

Definition at line 774 of file stl_bvector.h.

## ◆ size_type

template<typename _Alloc>

typedef size_t std::vector< bool, _Alloc >::size_type

Definition at line 765 of file stl_bvector.h.

## ◆ value_type

template<typename _Alloc>

typedef bool std::vector< bool, _Alloc >::value_type

Definition at line 764 of file stl_bvector.h.

## Constructor & Destructor Documentation

## ◆ vector() [1/8]

template<typename _Alloc>

std::vector< bool, _Alloc >::vector | ( | const allocator_type & | __a | ) |
| inlineexplicitconstexprnoexcept

Definition at line 797 of file stl_bvector.h.

## ◆ vector() [2/8]

template<typename _Alloc>

std::vector< bool, _Alloc >::vector | ( | size_type | __n,
|  | const allocator_type & | __a = allocator_type() )
| inlineexplicitconstexpr

Definition at line 803 of file stl_bvector.h.

## ◆ vector() [3/8]

template<typename _Alloc>

std::vector< bool, _Alloc >::vector | ( | size_type | __n,
|  | const bool & | __value,
|  | const allocator_type & | __a = allocator_type() )
| inlineconstexpr

Definition at line 808 of file stl_bvector.h.

## ◆ vector() [4/8]

template<typename _Alloc>

std::vector< bool, _Alloc >::vector | ( | const vector< bool, _Alloc > & | __x | ) |
| inlineconstexpr

Definition at line 822 of file stl_bvector.h.

## ◆ vector() [5/8]

template<typename _Alloc>

std::vector< bool, _Alloc >::vector | ( | vector< bool, _Alloc > && | __x,
|  | const __type_identity_t< allocator_type > & | __a )
| inlineconstexprnoexcept

Definition at line 855 of file stl_bvector.h.

## ◆ vector() [6/8]

template<typename _Alloc>

std::vector< bool, _Alloc >::vector | ( | const vector< bool, _Alloc > & | __x,
|  | const __type_identity_t< allocator_type > & | __a )
| inlineconstexpr

Definition at line 862 of file stl_bvector.h.

## ◆ vector() [7/8]

template<typename _Alloc>

std::vector< bool, _Alloc >::vector | ( | initializer_list< bool > | __l,
|  | const allocator_type & | __a = allocator_type() )
| inlineconstexpr

Definition at line 870 of file stl_bvector.h.

## ◆ vector() [8/8]

template<typename _Alloc>
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

std::vector< bool, _Alloc >::vector | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const allocator_type & | __a = allocator_type() )
| inlineconstexpr

Definition at line 883 of file stl_bvector.h.

## ◆ ~vector()

template<typename _Alloc>

std::vector< bool, _Alloc >::~vector | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 929 of file stl_bvector.h.

## Member Function Documentation

## ◆ _M_allocate_and_copy()

_Alloc_result std::vector< bool, _Alloc >::_M_allocate_and_copy | ( | size_type | __n,
|  | _ForwardIterator | __first,
|  | _ForwardIterator | __last )
| inlineconstexprprotected

Memory expansion handler. Uses the member allocation function to obtain at least n objects worth of memory, copies [first,last) into it, reports what was actually allocated.

Definition at line 1951 of file stl_vector.h.

## ◆ _M_assign_aux() [1/2]

template<typename _Alloc>
template<typename _ForwardIterator>

void std::vector< bool, _Alloc >::_M_assign_aux | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | std::forward_iterator_tag | )
| inlineconstexprprotected

Definition at line 1677 of file stl_bvector.h.

## ◆ _M_assign_aux() [2/2]

template<typename _Alloc>
template<typename _InputIterator>

void std::vector< bool, _Alloc >::_M_assign_aux | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | std::input_iterator_tag | )
| inlineconstexprprotected

Definition at line 1662 of file stl_bvector.h.

## ◆ _M_assign_dispatch()

void std::vector< bool, _Alloc >::_M_assign_dispatch | ( | _Integer | __n,
|  | _Integer | __val,
|  | __true_type | )
| inlineconstexprprotected

Definition at line 2096 of file stl_vector.h.

## ◆ _M_check_len()

template<typename _Alloc>

size_type std::vector< bool, _Alloc >::_M_check_len | ( | size_type | __n,
|  | const char * | __s ) const
| inlineconstexprprotected

Definition at line 1739 of file stl_bvector.h.

## ◆ _M_copy_aligned()

template<typename _Alloc>

iterator std::vector< bool, _Alloc >::_M_copy_aligned | ( | const_iterator | __first,
|  | const_iterator | __last,
|  | iterator | __result )
| inlineconstexprprotected

Definition at line 1548 of file stl_bvector.h.

## ◆ _M_create_storage()

void std::_Vector_base< bool, _Alloc >::_M_create_storage | ( | size_t | __n | ) |
| inlineconstexprprotected

Definition at line 455 of file stl_vector.h.

## ◆ _M_deallocate() [1/2]

template<typename _Alloc>

void std::_Bvector_base< _Alloc >::_M_deallocate | ( |  | ) |
| inlineconstexprprotectedinherited

Definition at line 702 of file stl_bvector.h.

## ◆ _M_deallocate() [2/2]

template<typename _Tp, typename _Alloc>

void std::_Vector_base< _Tp, _Alloc >::_M_deallocate | ( | pointer | __p,
|  | size_t | __n )
| inlineconstexprinherited

Definition at line 444 of file stl_vector.h.

## ◆ _M_default_append()

void vector::_M_default_append | ( | size_type | __n | ) |
| constexprprotected

Definition at line 2180 of file vector.tcc.

## ◆ _M_default_initialize()

void std::vector< bool, _Alloc >::_M_default_initialize | ( | size_type | __n | ) |
| inlineconstexprprotected

Definition at line 2078 of file stl_vector.h.

## ◆ _M_emplace_aux()

auto std::vector< bool, _Alloc >::_M_emplace_aux | ( | const_iterator | __position,
|  | _Args &&... | __args )-> iterator
| constexpr

Definition at line 366 of file vector.tcc.

## ◆ _M_erase() [1/2]

template<typename _Alloc>

vector< bool, _Alloc >::iterator std::vector< bool, _Alloc >::_M_erase | ( | iterator | __first,
|  | iterator | __last )
| constexprprotected

Definition at line 1277 of file vector.tcc.

## ◆ _M_erase() [2/2]

template<typename _Alloc>

vector< bool, _Alloc >::iterator std::vector< bool, _Alloc >::_M_erase | ( | iterator | __pos | ) |
| constexprprotected

Definition at line 1265 of file vector.tcc.

## ◆ _M_erase_at_end()

template<typename _Alloc>

void std::vector< bool, _Alloc >::_M_erase_at_end | ( | iterator | __pos | ) |
| inlineconstexprprotected

Definition at line 1750 of file stl_bvector.h.

## ◆ _M_fill_append()

void vector::_M_fill_append | ( | size_type | __n,
|  | const value_type & | __x )
| constexprprotected

Definition at line 2174 of file vector.tcc.

## ◆ _M_fill_assign()

template<typename _Alloc>

void std::vector< bool, _Alloc >::_M_fill_assign | ( | size_t | __n,
|  | bool | __x )
| inlineconstexprprotected

Definition at line 1645 of file stl_bvector.h.

## ◆ _M_fill_initialize()

void std::vector< bool, _Alloc >::_M_fill_initialize | ( | size_type | __n,
|  | const value_type & | __value )
| inlineconstexprprotected

Definition at line 2067 of file stl_vector.h.

## ◆ _M_fill_insert()

template<typename _Alloc>

void std::vector< bool, _Alloc >::_M_fill_insert | ( | iterator | __position,
|  | size_type | __n,
|  | bool | __x )
| constexprprotected

Definition at line 1166 of file vector.tcc.

## ◆ _M_get_Bit_allocator() [1/2]

template<typename _Alloc>

const _Bit_alloc_type & std::_Bvector_base< _Alloc >::_M_get_Bit_allocator | ( |  | ) | const
| inlineconstexprnoexceptinherited

Definition at line 650 of file stl_bvector.h.

## ◆ _M_get_Bit_allocator() [2/2]

template<typename _Alloc>

_Bit_alloc_type & std::_Bvector_base< _Alloc >::_M_get_Bit_allocator | ( |  | ) |
| inlineconstexprnoexceptinherited

Definition at line 645 of file stl_bvector.h.

## ◆ _M_initialize()

template<typename _Alloc>

void std::vector< bool, _Alloc >::_M_initialize | ( | size_type | __n | ) |
| inlineconstexprprotected

Definition at line 1558 of file stl_bvector.h.

## ◆ _M_initialize_range() [1/2]

template<typename _Alloc>
template<typename _ForwardIterator>

void std::vector< bool, _Alloc >::_M_initialize_range | ( | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | std::forward_iterator_tag | )
| inlineconstexprprotected

Definition at line 1620 of file stl_bvector.h.

## ◆ _M_initialize_range() [2/2]

template<typename _Alloc>
template<typename _InputIterator>

void std::vector< bool, _Alloc >::_M_initialize_range | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | std::input_iterator_tag | )
| inlineconstexprprotected

Definition at line 1610 of file stl_bvector.h.

## ◆ _M_initialize_value()

template<typename _Alloc>

void std::vector< bool, _Alloc >::_M_initialize_value | ( | bool | __x | ) |
| inlineconstexprprotectednoexcept

Definition at line 1572 of file stl_bvector.h.

## ◆ _M_insert_aux()

template<typename _Alloc>

void std::vector< bool, _Alloc >::_M_insert_aux | ( | iterator | __position,
|  | bool | __x )
| constexprprotected

Definition at line 1236 of file vector.tcc.

## ◆ _M_insert_dispatch()

void std::vector< bool, _Alloc >::_M_insert_dispatch | ( | iterator | __pos,
|  | _Integer | __n,
|  | _Integer | __val,
|  | __true_type | )
| inlineconstexprprotected

Definition at line 2136 of file stl_vector.h.

## ◆ _M_insert_range() [1/2]

template<typename _Alloc>
template<typename _InputIterator>

void std::vector< bool, _Alloc >::_M_insert_range | ( | iterator | __pos,
|  | _InputIterator | __first,
|  | _InputIterator | __last,
|  | std::input_iterator_tag | )
| inlineconstexprprotected

Definition at line 1717 of file stl_bvector.h.

## ◆ _M_insert_range() [2/2]

template<typename _Alloc>
template<typename _ForwardIterator>

void std::vector< bool, _Alloc >::_M_insert_range | ( | iterator | __position,
|  | _ForwardIterator | __first,
|  | _ForwardIterator | __last,
|  | std::forward_iterator_tag | )
| constexprprotected

Definition at line 1200 of file vector.tcc.

## ◆ _M_insert_rval()

auto vector::_M_insert_rval | ( | const_iterator | __position,
|  | value_type && | __v )
| constexprprotected

Definition at line 2254 of file vector.tcc.

## ◆ _M_move_data()

template<typename _Alloc>

void std::_Bvector_base< _Alloc >::_M_move_data | ( | _Bvector_base< _Alloc > && | __x | ) |
| inlineconstexprprotectednoexceptinherited

Definition at line 717 of file stl_bvector.h.

## ◆ _M_range_check()

template<typename _Alloc>

void std::vector< bool, _Alloc >::_M_range_check | ( | size_type | __n | ) | const
| inlineconstexprprotected

Definition at line 1180 of file stl_bvector.h.

## ◆ _M_range_initialize()

void std::vector< bool, _Alloc >::_M_range_initialize | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | std::input_iterator_tag | )
| inlineconstexprprotected

Definition at line 2020 of file stl_vector.h.

## ◆ _M_range_initialize_n()

void std::vector< bool, _Alloc >::_M_range_initialize_n | ( | _Iterator | __first,
|  | _Sentinel | __last,
|  | size_type | __n )
| inlineconstexprprotected

Definition at line 2050 of file stl_vector.h.

## ◆ _M_range_insert()

void vector::_M_range_insert | ( | iterator | __pos,
|  | _InputIterator | __first,
|  | _InputIterator | __last,
|  | std::input_iterator_tag | )
| constexprprotected

Definition at line 2155 of file vector.tcc.

## ◆ _M_realloc_append()

void vector::_M_realloc_append | ( | _Args &&... | __args | ) |
| constexprprotected

Definition at line 2249 of file vector.tcc.

## ◆ _M_realloc_insert()

void vector::_M_realloc_insert | ( | iterator | __position,
|  | _Args &&... | __args )
| constexprprotected

Definition at line 2244 of file vector.tcc.

## ◆ _M_reallocate()

template<typename _Alloc>

void std::vector< bool, _Alloc >::_M_reallocate | ( | size_type | __n | ) |
| constexprprotected

Definition at line 1148 of file vector.tcc.

## ◆ _M_replace_storage()

void std::vector< bool, _Alloc >::_M_replace_storage | ( | pointer | __start,
|  | pointer | __end,
|  | size_type | __cap )
| inlineconstexprprotected

Definition at line 1963 of file stl_vector.h.

## ◆ _M_replace_with()

void std::vector< bool, _Alloc >::_M_replace_with | ( | size_type | __n,
|  | _ForwardIterator | __first,
|  | _ForwardIterator | __last )
| inlineconstexprprotected

Definition at line 1976 of file stl_vector.h.

## ◆ _M_shrink_to_fit()

template<typename _Alloc>

bool std::vector< bool, _Alloc >::_M_shrink_to_fit | ( |  | ) |
| constexprprotected

Definition at line 1289 of file vector.tcc.

## ◆ _S_check_init_len()

constexpr size_type std::vector< bool, _Alloc >::_S_check_init_len | ( | size_type | __n,
|  | const allocator_type & | __a )
| inlinestaticconstexprprotected

Definition at line 2287 of file stl_vector.h.

## ◆ _S_max_size()

constexpr size_t std::_Vector_base< bool, _Alloc >::_S_max_size | ( | const _Tp_alloc_type & | __a | ) |
| inlinestaticconstexprnoexcept

Definition at line 321 of file stl_vector.h.

## ◆ _S_nword()

template<typename _Alloc>

constexpr size_t std::_Bvector_base< _Alloc >::_S_nword | ( | size_t | __n | ) |
| inlinestaticconstexprprotectedinherited

Definition at line 723 of file stl_bvector.h.

## ◆ assign() [1/3]

template<typename _Alloc>
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

void std::vector< bool, _Alloc >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last )
| inlineconstexpr

Definition at line 1012 of file stl_bvector.h.

## ◆ assign() [2/3]

template<typename _Alloc>

void std::vector< bool, _Alloc >::assign | ( | initializer_list< bool > | __l | ) |
| inlineconstexpr

Definition at line 1028 of file stl_bvector.h.

## ◆ assign() [3/3]

template<typename _Alloc>

void std::vector< bool, _Alloc >::assign | ( | size_type | __n,
|  | const bool & | __x )
| inlineconstexpr

Definition at line 1004 of file stl_bvector.h.

## ◆ at() [1/2]

template<typename _Alloc>

reference std::vector< bool, _Alloc >::at | ( | size_type | __n | ) |
| inlinenodiscardconstexpr

Definition at line 1192 of file stl_bvector.h.

## ◆ at() [2/2]

template<typename _Alloc>

const_reference std::vector< bool, _Alloc >::at | ( | size_type | __n | ) | const
| inlinenodiscardconstexpr

Definition at line 1200 of file stl_bvector.h.

## ◆ back() [1/2]

template<typename _Alloc>

reference std::vector< bool, _Alloc >::back | ( |  | ) |
| inlinenodiscardconstexpr

Definition at line 1234 of file stl_bvector.h.

## ◆ back() [2/2]

template<typename _Alloc>

const_reference std::vector< bool, _Alloc >::back | ( |  | ) | const
| inlinenodiscardconstexpr

Definition at line 1242 of file stl_bvector.h.

## ◆ begin() [1/2]

template<typename _Alloc>

const_iterator std::vector< bool, _Alloc >::begin | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 1073 of file stl_bvector.h.

## ◆ begin() [2/2]

template<typename _Alloc>

iterator std::vector< bool, _Alloc >::begin | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Definition at line 1068 of file stl_bvector.h.

## ◆ capacity()

template<typename _Alloc>

size_type std::vector< bool, _Alloc >::capacity | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 1148 of file stl_bvector.h.

## ◆ cbegin()

template<typename _Alloc>

const_iterator std::vector< bool, _Alloc >::cbegin | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 1109 of file stl_bvector.h.

## ◆ cend()

template<typename _Alloc>

const_iterator std::vector< bool, _Alloc >::cend | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 1114 of file stl_bvector.h.

## ◆ clear()

template<typename _Alloc>

void std::vector< bool, _Alloc >::clear | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 1518 of file stl_bvector.h.

## ◆ crbegin()

template<typename _Alloc>

const_reverse_iterator std::vector< bool, _Alloc >::crbegin | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 1119 of file stl_bvector.h.

## ◆ crend()

template<typename _Alloc>

const_reverse_iterator std::vector< bool, _Alloc >::crend | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 1124 of file stl_bvector.h.

## ◆ emplace()

template<typename _Alloc>
template<typename... _Args>

iterator std::vector< bool, _Alloc >::emplace | ( | const_iterator | __pos,
|  | _Args &&... | __args )
| inlineconstexpr

Definition at line 1540 of file stl_bvector.h.

## ◆ emplace_back()

template<typename _Alloc>
template<typename... _Args>

reference std::vector< bool, _Alloc >::emplace_back | ( | _Args &&... | __args | ) |
| inlineconstexpr

Definition at line 1529 of file stl_bvector.h.

## ◆ empty()

template<typename _Alloc>

bool std::vector< bool, _Alloc >::empty | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 1154 of file stl_bvector.h.

## ◆ end() [1/2]

template<typename _Alloc>

const_iterator std::vector< bool, _Alloc >::end | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 1083 of file stl_bvector.h.

## ◆ end() [2/2]

template<typename _Alloc>

iterator std::vector< bool, _Alloc >::end | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Definition at line 1078 of file stl_bvector.h.

## ◆ erase() [1/2]

template<typename _Alloc>

iterator std::vector< bool, _Alloc >::erase | ( | const_iterator | __first,
|  | const_iterator | __last )
| inlineconstexpr

Definition at line 1484 of file stl_bvector.h.

## ◆ erase() [2/2]

template<typename _Alloc>

iterator std::vector< bool, _Alloc >::erase | ( | const_iterator | __position | ) |
| inlineconstexpr

Definition at line 1475 of file stl_bvector.h.

## ◆ flip()

template<typename _Alloc>

void std::vector< bool, _Alloc >::flip | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 1509 of file stl_bvector.h.

## ◆ front() [1/2]

template<typename _Alloc>

reference std::vector< bool, _Alloc >::front | ( |  | ) |
| inlinenodiscardconstexpr

Definition at line 1218 of file stl_bvector.h.

## ◆ front() [2/2]

template<typename _Alloc>

const_reference std::vector< bool, _Alloc >::front | ( |  | ) | const
| inlinenodiscardconstexpr

Definition at line 1226 of file stl_bvector.h.

## ◆ get_allocator() [1/2]

template<typename _Alloc>

allocator_type std::vector< bool, _Alloc >::get_allocator | ( |  | ) | const
| inlineconstexpr

Definition at line 779 of file stl_bvector.h.

## ◆ get_allocator() [2/2]

| ( |  | ) | const

Get a copy of the memory allocation object.

## ◆ insert() [1/5]

template<typename _Alloc>

iterator std::vector< bool, _Alloc >::insert | ( | const_iterator | __p,
|  | initializer_list< bool > | __l )
| inlineconstexpr

Definition at line 1350 of file stl_bvector.h.

## ◆ insert() [2/5]

template<typename _Alloc>

iterator std::vector< bool, _Alloc >::insert | ( | const_iterator | __position | ) |
| inline

Definition at line 1302 of file stl_bvector.h.

## ◆ insert() [3/5]

template<typename _Alloc>
template<typename _InputIterator, typename = std::_RequireInputIter<_InputIterator>>

iterator std::vector< bool, _Alloc >::insert | ( | const_iterator | __position,
|  | _InputIterator | __first,
|  | _InputIterator | __last )
| inlineconstexpr

Definition at line 1311 of file stl_bvector.h.

## ◆ insert() [4/5]

template<typename _Alloc>

iterator std::vector< bool, _Alloc >::insert | ( | const_iterator | __position,
|  | const bool & | __x )
| inlineconstexpr

Definition at line 1285 of file stl_bvector.h.

## ◆ insert() [5/5]

template<typename _Alloc>

iterator std::vector< bool, _Alloc >::insert | ( | const_iterator | __position,
|  | size_type | __n,
|  | const bool & | __x )
| inlineconstexpr

Definition at line 1335 of file stl_bvector.h.

## ◆ max_size()

template<typename _Alloc>

size_type std::vector< bool, _Alloc >::max_size | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 1135 of file stl_bvector.h.

## ◆ operator=() [1/3]

template<typename _Alloc>

vector & std::vector< bool, _Alloc >::operator= | ( | const vector< bool, _Alloc > & | __x | ) |
| inlineconstexpr

Definition at line 933 of file stl_bvector.h.

## ◆ operator=() [2/3]

template<typename _Alloc>

vector & std::vector< bool, _Alloc >::operator= | ( | initializer_list< bool > | __l | ) |
| inlineconstexpr

Definition at line 991 of file stl_bvector.h.

## ◆ operator=() [3/3]

template<typename _Alloc>

vector & std::vector< bool, _Alloc >::operator= | ( | vector< bool, _Alloc > && | __x | ) |
| inlineconstexprnoexcept

Definition at line 965 of file stl_bvector.h.

## ◆ operator[]() [1/2]

template<typename _Alloc>

reference std::vector< bool, _Alloc >::operator[] | ( | size_type | __n | ) |
| inlinenodiscardconstexpr

Definition at line 1159 of file stl_bvector.h.

## ◆ operator[]() [2/2]

template<typename _Alloc>

const_reference std::vector< bool, _Alloc >::operator[] | ( | size_type | __n | ) | const
| inlinenodiscardconstexpr

Definition at line 1169 of file stl_bvector.h.

## ◆ pop_back()

template<typename _Alloc>

void std::vector< bool, _Alloc >::pop_back | ( |  | ) |
| inlineconstexpr

Definition at line 1469 of file stl_bvector.h.

## ◆ push_back()

template<typename _Alloc>

void std::vector< bool, _Alloc >::push_back | ( | bool | __x | ) |
| inlineconstexpr

Definition at line 1250 of file stl_bvector.h.

## ◆ rbegin() [1/2]

template<typename _Alloc>

const_reverse_iterator std::vector< bool, _Alloc >::rbegin | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 1093 of file stl_bvector.h.

## ◆ rbegin() [2/2]

template<typename _Alloc>

reverse_iterator std::vector< bool, _Alloc >::rbegin | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Definition at line 1088 of file stl_bvector.h.

## ◆ rend() [1/2]

template<typename _Alloc>

const_reverse_iterator std::vector< bool, _Alloc >::rend | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 1103 of file stl_bvector.h.

## ◆ rend() [2/2]

template<typename _Alloc>

reverse_iterator std::vector< bool, _Alloc >::rend | ( |  | ) |
| inlinenodiscardconstexprnoexcept

Definition at line 1098 of file stl_bvector.h.

## ◆ reserve()

template<typename _Alloc>

void std::vector< bool, _Alloc >::reserve | ( | size_type | __n | ) |
| inlineconstexpr

Definition at line 1208 of file stl_bvector.h.

## ◆ resize()

template<typename _Alloc>

void std::vector< bool, _Alloc >::resize | ( | size_type | __new_size,
|  | bool | __x = bool() )
| inlineconstexpr

Definition at line 1492 of file stl_bvector.h.

## ◆ shrink_to_fit()

template<typename _Alloc>

void std::vector< bool, _Alloc >::shrink_to_fit | ( |  | ) |
| inlineconstexpr

Definition at line 1503 of file stl_bvector.h.

## ◆ size()

template<typename _Alloc>

size_type std::vector< bool, _Alloc >::size | ( |  | ) | const
| inlinenodiscardconstexprnoexcept

Definition at line 1130 of file stl_bvector.h.

## ◆ swap() [1/2]

template<typename _Alloc>

constexpr void std::vector< bool, _Alloc >::swap | ( | reference | __x,
|  | reference | __y )
| inlinestaticconstexprnoexcept

Definition at line 1275 of file stl_bvector.h.

## ◆ swap() [2/2]

template<typename _Alloc>

void std::vector< bool, _Alloc >::swap | ( | vector< bool, _Alloc > & | __x | ) |
| inlineconstexprnoexcept

Definition at line 1260 of file stl_bvector.h.

## Friends And Related Symbol Documentation

## ◆ std::hash< vector >

template<typename _Alloc>

friend struct std::hash< vector >
| friend

Definition at line 753 of file stl_bvector.h.

The documentation for this class was generated from the following files:

- stl_bvector.h
- vector.tcc